//+------------------------------------------------------------------+
//|                                                 Level Sensor.mq4 |
//|                                          Copyright  2005, Sfen. |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Sfen"
#property indicator_chart_window
//---- input parameters
extern int MAX_HISTORY=500;
extern int STEP = 1;
extern int Xshift = 20;
extern double TargetH = 0;
extern double TargetL = 0;
double PointStep;
//-------------------------------------------------
int init()
{
   PointStep = 1.0*Point*STEP;
   return(0);
}
//-------------------------------------------------
double CSH(int shift)
{ return (MathMax(Open[shift],Close[shift]));   }
double CSL(int shift)
{ return (MathMin(Open[shift],Close[shift]));   }

string OBJECT_PREFIX = "LEVELS";
int ObjectId = 0;
//-------------------------------------------------
void   ObDeleteObjectsByPrefix(string Prefix)
{
   int L = StringLen(Prefix);
   int i=0; 
   while (i<ObjectsTotal())
   {
      string ObjName = ObjectName(i);
      if (StringSubstr(ObjName,0,L)!=Prefix) { i++; continue;}
      ObjectDelete(ObjName);
   }
}
//-------------------------------------------------
int deinit()
  {
   ObDeleteObjectsByPrefix(OBJECT_PREFIX);
   Comment("");
   return(0);
  }
//-------------------------------------------------
int start()
{
   string S;
   ObDeleteObjectsByPrefix(OBJECT_PREFIX);
   double HH = 0;
   double LL = 1000000;
   int History = MathMin(Bars,MAX_HISTORY);
   //
   //
   //
   int i, j, k;
   for (i=1; i<History; i++)
   {
      HH = MathMax(HH,CSH(i));
      LL = MathMin(LL,CSL(i));
   }
   int Profile_band = (HH-LL)/PointStep+1;
   int Target_band = (TargetH-TargetL)/PointStep+1;
   int Count[],TBCount[];
   ArrayResize(Count,Profile_band);  ArrayInitialize(Count,0);
   ArrayResize(TBCount,Target_band); ArrayInitialize(TBCount,0);
   
   for (i=1; i<History; i++)
   {
      for(double C=CSL(i); C<CSH(i); C+= PointStep)
      {
         int Index = (C-LL)/(PointStep);
         Count[Index]++;    
      }
      for (j=0; j<Target_band; j++) { TBCount[j]=0;  }
      int TB_HH = (TargetH-LL)/PointStep;
      int TB_LL = (TargetL-LL)/PointStep;
      for(j=0, Index=TB_LL; j<Target_band; j++, Index++)
      {
         TBCount[j] = Count[Index];
         double TB_POC = TargetL + ArrayMaximum(TBCount)*PointStep;
      }
   }
//   Comment("TB_POC = ",DoubleToStr(TB_POC, Digits));
   //
   //
   //
   for (i=0; i<Profile_band; i++)
   {
      double StartX = Time[0] + Xshift*60*Period();
      double StartY = LL + PointStep*i;
//      double EndX   = Time[Count[i]] + Xshift*60*Period();
      double EndX   = Count[i]*60*Period()+Time[0]+ Xshift*60*Period();
      double EndY   = StartY;

      string ObjName = OBJECT_PREFIX+" "+i;
      ObjectDelete(ObjName);
      ObjectCreate(ObjName,OBJ_TREND,0,StartX,StartY,EndX,EndY);
      ObjectSet(ObjName,OBJPROP_RAY,0);
      ObjectSet(ObjName,OBJPROP_COLOR,Khaki);
   }
   return(0);
}
//+------------------------------------------------------------------+


